# Apply changes to positions.

POST https://api.letsdeel.com/rest/v2/hris/positions/apply_changes
Content-Type: application/json

Apply add, edit, and delete operations to profiles.
 **Token scopes**: `profile:write`

Reference: https://developer.deel.com/api/reference/endpoints/positions/apply-changes-positions

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Deel HRIS SCIM API
  version: 1.0.0
paths:
  /hris/positions/apply_changes:
    post:
      operationId: apply-changes-positions
      summary: Apply changes to positions.
      description: |-
        Apply add, edit, and delete operations to profiles.
         **Token scopes**: `profile:write`
      tags:
        - subpackage_positions
      parameters:
        - name: Authorization
          in: header
          description: >
            ## Authentication

            The Deel API uses bearer tokens to authenticate requests. All API
            calls must be made over HTTPS — calls over plain HTTP or without
            authentication will fail.


            ```curl

            curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
              -H 'Authorization: Bearer YOUR-TOKEN-HERE'
            ```


            [Learn more about authentication](/api/authentication)
          required: true
          schema:
            type: string
      responses:
        '204':
          description: Successful operation
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/Positions_applyChangesPositions_Response_204
        '400':
          description: Bad Request. Invalid input parameters.
          content:
            application/json:
              schema:
                description: Any type
        '401':
          description: Unauthorized. Invalid or expired token.
          content:
            application/json:
              schema:
                description: Any type
        '403':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '404':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '500':
          description: Internal Server Error. Could not process the request.
          content:
            application/json:
              schema:
                description: Any type
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                data:
                  $ref: >-
                    #/components/schemas/HrisPositionsApplyChangesPostRequestBodyContentApplicationJsonSchemaData
servers:
  - url: https://api.letsdeel.com/rest/v2
  - url: https://api-staging.letsdeel.com/rest/v2
components:
  schemas:
    HrisPositionsApplyChangesPostRequestBodyContentApplicationJsonSchemaDataAddItems:
      type: object
      properties:
        role_id:
          type:
            - string
            - 'null'
          format: uuid
          description: Id of the role to be assigned to the position.
        team_id:
          type: string
          format: uuid
          description: Id of the team to be assigned to the position.
        is_supportive:
          type: boolean
          description: Flag to indicate if the position is supportive.
      required:
        - team_id
      title: >-
        HrisPositionsApplyChangesPostRequestBodyContentApplicationJsonSchemaDataAddItems
    HrisPositionsApplyChangesPostRequestBodyContentApplicationJsonSchemaDataEditItems:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: Id of the position to be edited.
        role_id:
          type:
            - string
            - 'null'
          format: uuid
          description: Id of the role to be assigned to the position.
        is_supportive:
          type: boolean
          description: Flag to indicate if the position is supportive.
      required:
        - id
      title: >-
        HrisPositionsApplyChangesPostRequestBodyContentApplicationJsonSchemaDataEditItems
    HrisPositionsApplyChangesPostRequestBodyContentApplicationJsonSchemaDataDeleteItems:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: Id of the position to be deleted.
      required:
        - id
      title: >-
        HrisPositionsApplyChangesPostRequestBodyContentApplicationJsonSchemaDataDeleteItems
    HrisPositionsApplyChangesPostRequestBodyContentApplicationJsonSchemaData:
      type: object
      properties:
        add:
          type: array
          items:
            $ref: >-
              #/components/schemas/HrisPositionsApplyChangesPostRequestBodyContentApplicationJsonSchemaDataAddItems
        edit:
          type: array
          items:
            $ref: >-
              #/components/schemas/HrisPositionsApplyChangesPostRequestBodyContentApplicationJsonSchemaDataEditItems
        delete:
          type: array
          items:
            $ref: >-
              #/components/schemas/HrisPositionsApplyChangesPostRequestBodyContentApplicationJsonSchemaDataDeleteItems
        profile_id:
          type: string
          format: uuid
          description: Id of the profile to which the positions belong.
      required:
        - profile_id
      title: HrisPositionsApplyChangesPostRequestBodyContentApplicationJsonSchemaData
    Positions_applyChangesPositions_Response_204:
      type: object
      properties: {}
      description: Empty response body
      title: Positions_applyChangesPositions_Response_204
    ApiErrorRequest:
      type: object
      properties:
        method:
          type: string
          description: The HTTP method of the failed request
        url:
          type: string
          description: The relative URL of the failed request
        status:
          type: number
          format: double
          description: The status code of the response
        api_req_id:
          type: string
          description: The request ID of the failed request
        docs:
          type: string
          description: >-
            A link to the official documentation for the requested endpoint
            resource
        source:
          type: string
          description: The source handler which produced the returned error
        code:
          type: number
          format: double
          description: The code of the source handler which produced the returned error
      title: ApiErrorRequest
    ApiError:
      type: object
      properties:
        message:
          type: string
          description: A description of the returned error
        path:
          type: string
          description: The JSON path where input validation failed
      title: ApiError
    ApiErrorContainer:
      type: object
      properties:
        request:
          $ref: '#/components/schemas/ApiErrorRequest'
        errors:
          type: array
          items:
            $ref: '#/components/schemas/ApiError'
      title: ApiErrorContainer
  securitySchemes:
    deelToken:
      type: http
      scheme: bearer
      description: >
        ## Authentication

        The Deel API uses bearer tokens to authenticate requests. All API calls
        must be made over HTTPS — calls over plain HTTP or without
        authentication will fail.


        ```curl

        curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
          -H 'Authorization: Bearer YOUR-TOKEN-HERE'
        ```


        [Learn more about authentication](/api/authentication)
    oauth2:
      type: http
      scheme: bearer
      description: >-
        Standard OAuth2 security scheme based on
        https://swagger.io/docs/specification/authentication/

```

## SDK Code Examples

```python
import requests

url = "https://api.letsdeel.com/rest/v2/hris/positions/apply_changes"

payload = { "body": { "data": {
            "profile_id": "a3f1c9e2-7b4d-4f8a-9c3e-2d5f7a1b6c8d",
            "add": [
                {
                    "team_id": "b2d3f4a5-6c7e-8f90-1234-56789abcdef0",
                    "role_id": "c1d2e3f4-5678-90ab-cdef-1234567890ab",
                    "is_supportive": True
                }
            ],
            "edit": [
                {
                    "id": "d4e5f6a7-b8c9-0d1e-2f3a-4b5c6d7e8f90",
                    "role_id": "e1f2a3b4-c5d6-7e8f-9012-3456789abcde",
                    "is_supportive": False
                }
            ],
            "delete": [{ "id": "f7a8b9c0-d1e2-3f4a-5b6c-7d8e9f0a1b2c" }]
        } } }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/v2/hris/positions/apply_changes';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"body":{"data":{"profile_id":"a3f1c9e2-7b4d-4f8a-9c3e-2d5f7a1b6c8d","add":[{"team_id":"b2d3f4a5-6c7e-8f90-1234-56789abcdef0","role_id":"c1d2e3f4-5678-90ab-cdef-1234567890ab","is_supportive":true}],"edit":[{"id":"d4e5f6a7-b8c9-0d1e-2f3a-4b5c6d7e8f90","role_id":"e1f2a3b4-c5d6-7e8f-9012-3456789abcde","is_supportive":false}],"delete":[{"id":"f7a8b9c0-d1e2-3f4a-5b6c-7d8e9f0a1b2c"}]}}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/v2/hris/positions/apply_changes"

	payload := strings.NewReader("{\n  \"body\": {\n    \"data\": {\n      \"profile_id\": \"a3f1c9e2-7b4d-4f8a-9c3e-2d5f7a1b6c8d\",\n      \"add\": [\n        {\n          \"team_id\": \"b2d3f4a5-6c7e-8f90-1234-56789abcdef0\",\n          \"role_id\": \"c1d2e3f4-5678-90ab-cdef-1234567890ab\",\n          \"is_supportive\": true\n        }\n      ],\n      \"edit\": [\n        {\n          \"id\": \"d4e5f6a7-b8c9-0d1e-2f3a-4b5c6d7e8f90\",\n          \"role_id\": \"e1f2a3b4-c5d6-7e8f-9012-3456789abcde\",\n          \"is_supportive\": false\n        }\n      ],\n      \"delete\": [\n        {\n          \"id\": \"f7a8b9c0-d1e2-3f4a-5b6c-7d8e9f0a1b2c\"\n        }\n      ]\n    }\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/v2/hris/positions/apply_changes")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"body\": {\n    \"data\": {\n      \"profile_id\": \"a3f1c9e2-7b4d-4f8a-9c3e-2d5f7a1b6c8d\",\n      \"add\": [\n        {\n          \"team_id\": \"b2d3f4a5-6c7e-8f90-1234-56789abcdef0\",\n          \"role_id\": \"c1d2e3f4-5678-90ab-cdef-1234567890ab\",\n          \"is_supportive\": true\n        }\n      ],\n      \"edit\": [\n        {\n          \"id\": \"d4e5f6a7-b8c9-0d1e-2f3a-4b5c6d7e8f90\",\n          \"role_id\": \"e1f2a3b4-c5d6-7e8f-9012-3456789abcde\",\n          \"is_supportive\": false\n        }\n      ],\n      \"delete\": [\n        {\n          \"id\": \"f7a8b9c0-d1e2-3f4a-5b6c-7d8e9f0a1b2c\"\n        }\n      ]\n    }\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.letsdeel.com/rest/v2/hris/positions/apply_changes")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"body\": {\n    \"data\": {\n      \"profile_id\": \"a3f1c9e2-7b4d-4f8a-9c3e-2d5f7a1b6c8d\",\n      \"add\": [\n        {\n          \"team_id\": \"b2d3f4a5-6c7e-8f90-1234-56789abcdef0\",\n          \"role_id\": \"c1d2e3f4-5678-90ab-cdef-1234567890ab\",\n          \"is_supportive\": true\n        }\n      ],\n      \"edit\": [\n        {\n          \"id\": \"d4e5f6a7-b8c9-0d1e-2f3a-4b5c6d7e8f90\",\n          \"role_id\": \"e1f2a3b4-c5d6-7e8f-9012-3456789abcde\",\n          \"is_supportive\": false\n        }\n      ],\n      \"delete\": [\n        {\n          \"id\": \"f7a8b9c0-d1e2-3f4a-5b6c-7d8e9f0a1b2c\"\n        }\n      ]\n    }\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.letsdeel.com/rest/v2/hris/positions/apply_changes', [
  'body' => '{
  "body": {
    "data": {
      "profile_id": "a3f1c9e2-7b4d-4f8a-9c3e-2d5f7a1b6c8d",
      "add": [
        {
          "team_id": "b2d3f4a5-6c7e-8f90-1234-56789abcdef0",
          "role_id": "c1d2e3f4-5678-90ab-cdef-1234567890ab",
          "is_supportive": true
        }
      ],
      "edit": [
        {
          "id": "d4e5f6a7-b8c9-0d1e-2f3a-4b5c6d7e8f90",
          "role_id": "e1f2a3b4-c5d6-7e8f-9012-3456789abcde",
          "is_supportive": false
        }
      ],
      "delete": [
        {
          "id": "f7a8b9c0-d1e2-3f4a-5b6c-7d8e9f0a1b2c"
        }
      ]
    }
  }
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/v2/hris/positions/apply_changes");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"body\": {\n    \"data\": {\n      \"profile_id\": \"a3f1c9e2-7b4d-4f8a-9c3e-2d5f7a1b6c8d\",\n      \"add\": [\n        {\n          \"team_id\": \"b2d3f4a5-6c7e-8f90-1234-56789abcdef0\",\n          \"role_id\": \"c1d2e3f4-5678-90ab-cdef-1234567890ab\",\n          \"is_supportive\": true\n        }\n      ],\n      \"edit\": [\n        {\n          \"id\": \"d4e5f6a7-b8c9-0d1e-2f3a-4b5c6d7e8f90\",\n          \"role_id\": \"e1f2a3b4-c5d6-7e8f-9012-3456789abcde\",\n          \"is_supportive\": false\n        }\n      ],\n      \"delete\": [\n        {\n          \"id\": \"f7a8b9c0-d1e2-3f4a-5b6c-7d8e9f0a1b2c\"\n        }\n      ]\n    }\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["body": ["data": [
      "profile_id": "a3f1c9e2-7b4d-4f8a-9c3e-2d5f7a1b6c8d",
      "add": [
        [
          "team_id": "b2d3f4a5-6c7e-8f90-1234-56789abcdef0",
          "role_id": "c1d2e3f4-5678-90ab-cdef-1234567890ab",
          "is_supportive": true
        ]
      ],
      "edit": [
        [
          "id": "d4e5f6a7-b8c9-0d1e-2f3a-4b5c6d7e8f90",
          "role_id": "e1f2a3b4-c5d6-7e8f-9012-3456789abcde",
          "is_supportive": false
        ]
      ],
      "delete": [["id": "f7a8b9c0-d1e2-3f4a-5b6c-7d8e9f0a1b2c"]]
    ]]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/v2/hris/positions/apply_changes")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```